summaryrefslogtreecommitdiffstats
path: root/bitbake
diff options
context:
space:
mode:
authorPeter Seebach <peter.seebach@windriver.com>2012-10-10 17:11:54 -0500
committerRichard Purdie <richard.purdie@linuxfoundation.org>2013-08-20 22:43:42 +0100
commitf6ab9274bc453eee9b93fa377ccce6134c43899c (patch)
tree186a7fa0e05b3dc9a2fd4d6a3df3168a04feb1ba /bitbake
parentfe227a023e30f6651618423ab527cde21a350d1a (diff)
downloadast2050-yocto-poky-f6ab9274bc453eee9b93fa377ccce6134c43899c.zip
ast2050-yocto-poky-f6ab9274bc453eee9b93fa377ccce6134c43899c.tar.gz
bitbake: build.py: Provide useful diagnostics when exiting.
Running scripts with 'set -e' produces silent failures with no diagnostic. Add an exit handler which produces diagnostics, including details of what was running if the shell seems to be bash. (Bitbake rev: e213e6a4c297a4f1c22eed15bd7b4cbc0e9eab4f) Signed-off-by: Peter Seebach <peter.seebach@windriver.com> Signed-off-by: Richard Purdie <richard.purdie@linuxfoundation.org>
Diffstat (limited to 'bitbake')
-rw-r--r--bitbake/lib/bb/build.py25
1 files changed, 24 insertions, 1 deletions
diff --git a/bitbake/lib/bb/build.py b/bitbake/lib/bb/build.py
index e28655e..6fffbc5 100644
--- a/bitbake/lib/bb/build.py
+++ b/bitbake/lib/bb/build.py
@@ -250,7 +250,24 @@ def exec_func_shell(func, d, runfile, cwd=None):
d.delVarFlag('PWD', 'export')
with open(runfile, 'w') as script:
- script.write('#!/bin/sh -e\n')
+ script.write('''#!/bin/sh\n
+# Emit a useful diagnostic if something fails:
+bb_exit_handler() {
+ ret=$?
+ case $ret in
+ 0) ;;
+ *) case $BASH_VERSION in
+ "") echo "WARNING: exit code $ret from a shell command.";;
+ *) echo "WARNING: ${BASH_SOURCE[0]}:${BASH_LINENO[0]} exit $ret from
+ \"$BASH_COMMAND\"";;
+ esac
+ exit $ret
+ esac
+}
+trap 'bb_exit_handler' 0
+set -e
+''')
+
bb.data.emit_func(func, script, d)
if bb.msg.loggerVerboseLogs:
@@ -258,6 +275,12 @@ def exec_func_shell(func, d, runfile, cwd=None):
if cwd:
script.write("cd %s\n" % cwd)
script.write("%s\n" % func)
+ script.write('''
+# cleanup
+ret=$?
+trap '' 0
+exit $?
+''')
os.chmod(runfile, 0775)
OpenPOWER on IntegriCloud